Index: src/language/data-io/list.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/list.q,v
retrieving revision 1.17
diff -u -p -r1.17 list.q
--- src/language/data-io/list.q	26 Oct 2006 06:16:36 -0000	1.17
+++ src/language/data-io/list.q	1 Nov 2006 04:17:21 -0000
@@ -213,9 +213,9 @@ cmd_list (struct dataset *ds)
       strcpy (casenum_var.name, "Case#");
       casenum_var.type = NUMERIC;
       casenum_var.fv = -1;
-      casenum_var.print = make_output_format (FMT_F,
-                                              (cmd.last == LONG_MAX
-                                               ? 5 : intlog10 (cmd.last)), 0);
+      casenum_var.print = fmt_for_output (FMT_F,
+                                          (cmd.last == LONG_MAX
+                                           ? 5 : intlog10 (cmd.last)), 0);
 
       /* Add the weight variable at the beginning of the variable list. */
       cmd.n_variables++;
@@ -664,7 +664,7 @@ list_cases (const struct ccase *c, void 
 		ds_put_char_multiple(&line_buffer, ' ', width - v->print.w);
 	      }
 
-            if ((formats[v->print.type].cat & FCAT_STRING) || v->fv != -1)
+            if (fmt_is_string (v->print.type) || v->fv != -1)
 	      {
                 data_out (ds_put_uninit(&line_buffer, v->print.w),
 			  &v->print, case_data (c, v->fv));
@@ -701,7 +701,7 @@ list_cases (const struct ccase *c, void 
 	    struct variable *v = cmd.v_variables[column];
 	    char buf[256];
 	    
-            if ((formats[v->print.type].cat & FCAT_STRING) || v->fv != -1)
+            if (fmt_is_string (v->print.type) || v->fv != -1)
 	      data_out (buf, &v->print, case_data (c, v->fv));
             else 
               {
Index: src/language/data-io/matrix-data.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/matrix-data.c,v
retrieving revision 1.15
diff -u -p -r1.15 matrix-data.c
--- src/language/data-io/matrix-data.c	29 Oct 2006 09:51:36 -0000	1.15
+++ src/language/data-io/matrix-data.c	1 Nov 2006 04:17:23 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -871,7 +871,7 @@ static int
 	  di.e = ss_end (s);
 	  di.v = (union value *) &token->number;
 	  di.f1 = dfm_get_column (reader, di.s);
-	  di.format = make_output_format (FMT_F, token->length, 0);
+	  di.format = fmt_for_output (FMT_F, token->length, 0);
 
 	  data_in (&di);
 	}
Index: src/language/data-io/placement-parser.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/placement-parser.c,v
retrieving revision 1.1
diff -u -p -r1.1 placement-parser.c
--- src/language/data-io/placement-parser.c	18 Jul 2006 04:57:01 -0000	1.1
+++ src/language/data-io/placement-parser.c	1 Nov 2006 04:17:23 -0000
@@ -39,14 +39,14 @@
    placement. */
 enum 
   {
-    PRS_TYPE_T = -1,            /* Tab to absolute column. */
-    PRS_TYPE_X = -2,            /* Skip columns. */
-    PRS_TYPE_NEW_REC = -3       /* Next record. */
+    PRS_TYPE_T = SCHAR_MAX - 3, /* Tab to absolute column. */
+    PRS_TYPE_X,                 /* Skip columns. */
+    PRS_TYPE_NEW_REC            /* Next record. */
   };
 
-static bool fixed_parse_columns (struct pool *, size_t var_cnt,
+static bool fixed_parse_columns (struct pool *, size_t var_cnt, bool for_input,
                                  struct fmt_spec **, size_t *);
-static bool fixed_parse_fortran (struct pool *,
+static bool fixed_parse_fortran (struct pool *, bool for_input,
                                  struct fmt_spec **, size_t *);
 
 /* Parses Fortran-like or column-based specifications for placing
@@ -65,23 +65,23 @@ static bool fixed_parse_fortran (struct 
    Uses POOL for allocation.  When the caller is finished
    interpreting *FORMATS, POOL may be destroyed. */
 bool
-parse_var_placements (struct pool *pool, size_t var_cnt,
+parse_var_placements (struct pool *pool, size_t var_cnt, bool for_input,
                       struct fmt_spec **formats, size_t *format_cnt) 
 {
   assert (var_cnt > 0);
   if (lex_is_number ())
-    return fixed_parse_columns (pool, var_cnt, formats, format_cnt);
+    return fixed_parse_columns (pool, var_cnt, for_input, formats, format_cnt);
   else if (lex_match ('(')) 
     {
       size_t assignment_cnt;
       size_t i;
 
-      if (!fixed_parse_fortran (pool, formats, format_cnt))
+      if (!fixed_parse_fortran (pool, for_input, formats, format_cnt))
         return false; 
 
       assignment_cnt = 0;
       for (i = 0; i < *format_cnt; i++)
-        assignment_cnt += (*formats)[i].type >= 0;
+        assignment_cnt += (*formats)[i].type < FMT_NUMBER_OF_FORMATS;
 
       if (assignment_cnt != var_cnt)
         {
@@ -103,7 +103,7 @@ parse_var_placements (struct pool *pool,
 
 /* Implements parse_var_placements for column-based formats. */
 static bool
-fixed_parse_columns (struct pool *pool, size_t var_cnt,
+fixed_parse_columns (struct pool *pool, size_t var_cnt, bool for_input,
                      struct fmt_spec **formats, size_t *format_cnt)
 {
   struct fmt_spec format;
@@ -153,7 +153,7 @@ fixed_parse_columns (struct pool *pool, 
       format.type = FMT_F;
       format.d = 0;
     }
-  if (!check_input_specifier (&format, 1))
+  if (!fmt_check (&format, for_input))
     return false;
 
   *formats = pool_nalloc (pool, var_cnt + 1, sizeof **formats);
@@ -167,7 +167,7 @@ fixed_parse_columns (struct pool *pool, 
 
 /* Implements parse_var_placements for Fortran-like formats. */
 static bool
-fixed_parse_fortran (struct pool *pool,
+fixed_parse_fortran (struct pool *pool, bool for_input,
                      struct fmt_spec **formats, size_t *format_cnt)
 {
   size_t formats_allocated = 0;
@@ -195,7 +195,8 @@ fixed_parse_fortran (struct pool *pool,
       if (lex_match ('('))
         {
           /* Call ourselves recursively to handle parentheses. */
-          if (!fixed_parse_fortran (pool, &new_formats, &new_format_cnt))
+          if (!fixed_parse_fortran (pool, for_input,
+                                    &new_formats, &new_format_cnt))
             return false;
         }
       else
@@ -221,12 +222,12 @@ fixed_parse_fortran (struct pool *pool,
                 }
               else 
                 {
-                  if (!fmt_type_from_string (type, &f.type)) 
+                  if (!fmt_from_name (type, &f.type)) 
                     {
                       msg (SE, _("Unknown format type \"%s\"."), type);
                       return false;
                     }
-                  if (!check_input_specifier (&f, 1))
+                  if (!fmt_check (&f, for_input))
                     return false;
                 }
             } 
@@ -284,7 +285,7 @@ execute_placement_format (const struct f
       return true;
 
     default:
-      assert (format->type >= 0 && format->type < FMT_NUMBER_OF_FORMATS);
+      assert (format->type < FMT_NUMBER_OF_FORMATS);
       return false;
     }
 }
Index: src/language/data-io/placement-parser.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/placement-parser.h,v
retrieving revision 1.1
diff -u -p -r1.1 placement-parser.h
--- src/language/data-io/placement-parser.h	18 Jul 2006 04:57:01 -0000	1.1
+++ src/language/data-io/placement-parser.h	1 Nov 2006 04:17:23 -0000
@@ -27,7 +27,7 @@ struct fmt_spec;
 struct pool;
 
 bool parse_record_placement (int *record, int *column);
-bool parse_var_placements (struct pool *, size_t var_cnt,
+bool parse_var_placements (struct pool *, size_t var_cnt, bool for_input,
                            struct fmt_spec **, size_t *format_cnt);
 bool execute_placement_format (const struct fmt_spec *,
                                int *record, int *column);
Index: src/language/data-io/print.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/print.c,v
retrieving revision 1.17
diff -u -p -r1.17 print.c
--- src/language/data-io/print.c	29 Oct 2006 00:01:53 -0000	1.17
+++ src/language/data-io/print.c	1 Nov 2006 04:17:23 -0000
@@ -317,7 +317,8 @@ parse_variable_argument (const struct di
 
   if (lex_is_number () || token == '(')
     {
-      if (!parse_var_placements (tmp_pool, var_cnt, &formats, &format_cnt))
+      if (!parse_var_placements (tmp_pool, var_cnt, false,
+                                 &formats, &format_cnt))
         return false;
       add_space = false;
     }
@@ -345,7 +346,7 @@ parse_variable_argument (const struct di
         struct prt_out_spec *spec;
 
         var = vars[var_idx++];
-        if (!check_specifier_width (f, var->width, true))
+        if (!fmt_check_width_compat (f, var->width))
           return false;
 
         spec = pool_alloc (trns->pool, sizeof *spec);
@@ -362,7 +363,8 @@ parse_variable_argument (const struct di
            that usually contains a period. */ 
         spec->sysmis_as_spaces = (which_formats == WRITE
                                   && var->type == NUMERIC
-                                  && !fmt_is_binary (spec->format.type));
+                                  && (fmt_get_category (spec->format.type)
+                                      != FMT_CAT_BINARY));
 
         ll_push_tail (&trns->specs, &spec->ll);
 
@@ -397,6 +399,7 @@ dump_table (struct print_trns *trns, con
   row = 1;
   ll_for_each (spec, struct prt_out_spec, ll, &trns->specs) 
     {
+      char fmt_string[FMT_STRING_LEN_MAX + 1];
       int width;
       switch (spec->type)
         {
@@ -408,7 +411,7 @@ dump_table (struct print_trns *trns, con
         case PRT_VAR:
           tab_text (t, 0, row, TAB_LEFT, spec->var->name);
           tab_text (t, 3, row, TAB_LEFT | TAB_FIX,
-                    fmt_to_string (&spec->format));
+                    fmt_to_string (&spec->format, fmt_string));
           width = spec->format.w;
           break;
         default:
Index: src/language/dictionary/formats.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/formats.c,v
retrieving revision 1.11
diff -u -p -r1.11 formats.c
--- src/language/dictionary/formats.c	26 Oct 2006 06:16:36 -0000	1.11
+++ src/language/dictionary/formats.c	1 Nov 2006 04:17:23 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -93,8 +93,8 @@ internal_cmd_formats (struct dataset *ds
 	  goto fail;
 	}
       if (!parse_format_specifier (&f)
-          || !check_output_specifier (&f, true)
-          || !check_specifier_type (&f, NUMERIC, true))
+          || !fmt_check_output (&f)
+          || !fmt_check_type_compat (&f, NUMERIC))
 	goto fail;
 
       if (!lex_match (')'))
Index: src/language/dictionary/missing-values.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/missing-values.c,v
retrieving revision 1.9
diff -u -p -r1.9 missing-values.c
--- src/language/dictionary/missing-values.c	26 Oct 2006 06:16:36 -0000	1.9
+++ src/language/dictionary/missing-values.c	1 Nov 2006 04:17:23 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
Index: src/language/dictionary/numeric.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/numeric.c,v
retrieving revision 1.13
diff -u -p -r1.13 numeric.c
--- src/language/dictionary/numeric.c	26 Oct 2006 06:16:36 -0000	1.13
+++ src/language/dictionary/numeric.c	1 Nov 2006 04:17:24 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -59,10 +59,11 @@ cmd_numeric (struct dataset *ds)
 	{
 	  if (!parse_format_specifier (&f))
 	    goto fail;
-	  if (formats[f.type].cat & FCAT_STRING)
+	  if (fmt_is_string (f.type))
 	    {
+              char str[FMT_STRING_LEN_MAX + 1];
 	      msg (SE, _("Format type %s may not be used with a numeric "
-		   "variable."), fmt_to_string (&f));
+                         "variable."), fmt_to_string (&f, str));
 	      goto fail;
 	    }
 
@@ -129,10 +130,11 @@ cmd_string (struct dataset *ds)
 
       if (!lex_force_match ('(') || !parse_format_specifier (&f))
 	goto fail;
-      if (!(formats[f.type].cat & FCAT_STRING))
+      if (!fmt_is_string (f.type))
 	{
+          char str[FMT_STRING_LEN_MAX + 1];
 	  msg (SE, _("Format type %s may not be used with a string "
-	       "variable."), fmt_to_string (&f));
+                     "variable."), fmt_to_string (&f, str));
 	  goto fail;
 	}
 
@@ -142,17 +144,7 @@ cmd_string (struct dataset *ds)
 	  goto fail;
 	}
 
-      switch (f.type)
-	{
-	case FMT_A:
-	  width = f.w;
-	  break;
-	case FMT_AHEX:
-	  width = f.w / 2;
-	  break;
-	default:
-          NOT_REACHED ();
-	}
+      width = fmt_var_width (&f);
 
       /* Create each variable. */
       for (i = 0; i < nv; i++)
Index: src/language/dictionary/sys-file-info.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/sys-file-info.c,v
retrieving revision 1.11
diff -u -p -r1.11 sys-file-info.c
--- src/language/dictionary/sys-file-info.c	26 Oct 2006 06:16:36 -0000	1.11
+++ src/language/dictionary/sys-file-info.c	1 Nov 2006 04:17:24 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -454,17 +454,19 @@ describe_variable (struct variable *v, s
       && v->print.w == v->write.w
       && v->print.d == v->write.d)
     {
+      char str[FMT_STRING_LEN_MAX + 1];
       tab_joint_text (t, 1, r, 2, r, TAB_LEFT | TAT_PRINTF, _("Format: %s"),
-		      fmt_to_string (&v->print));
+		      fmt_to_string (&v->print, str));
       r++;
     }
   else
     {
+      char str[FMT_STRING_LEN_MAX + 1];
       tab_joint_text (t, 1, r, 2, r, TAB_LEFT | TAT_PRINTF,
-		      _("Print Format: %s"), fmt_to_string (&v->print));
+		      _("Print Format: %s"), fmt_to_string (&v->print, str));
       r++;
       tab_joint_text (t, 1, r, 2, r, TAB_LEFT | TAT_PRINTF,
-		      _("Write Format: %s"), fmt_to_string (&v->write));
+		      _("Write Format: %s"), fmt_to_string (&v->write, str));
       r++;
     }
 
Index: src/language/expressions/evaluate.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/evaluate.c,v
retrieving revision 1.8
diff -u -p -r1.8 evaluate.c
--- src/language/expressions/evaluate.c	26 Oct 2006 06:16:36 -0000	1.8
+++ src/language/expressions/evaluate.c	1 Nov 2006 04:17:24 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -304,9 +304,11 @@ expr_debug_print_postfix (const struct e
                    op->string.string != NULL ? op->string.string : "");
           break;
         case OP_format:
-          fprintf (stderr, "f<%s%d.%d>",
-                  formats[op->format->type].name,
-                  op->format->w, op->format->d);
+          {
+            char str[FMT_STRING_LEN_MAX + 1];
+            fmt_to_string (op->format, str);
+            fprintf (stderr, "f<%s>", str); 
+          }
           break;
         case OP_variable:
           fprintf (stderr, "v<%s>", op->variable->name);
Index: src/language/expressions/operations.def
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/operations.def,v
retrieving revision 1.6
diff -u -p -r1.6 operations.def
--- src/language/expressions/operations.def	26 Oct 2006 06:16:36 -0000	1.6
+++ src/language/expressions/operations.def	1 Nov 2006 04:17:25 -0000
@@ -1,4 +1,23 @@
 // -*- c -*-
+//
+// PSPP - computes sample statistics.
+// Copyright (C) 2005, 2006 Free Software Foundation, Inc.
+// Written by Ben Pfaff <blp@gnu.org>.
+// 
+// This program is free software; you can redistribute it and/or
+// modify it under the terms of the GNU General Public License as
+// published by the Free Software Foundation; either version 2 of the
+// License, or (at your option) any later version.
+// 
+// This program is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+// General Public License for more details.
+// 
+// You should have received a copy of the GNU General Public License
+// along with this program; if not, write to the Free Software
+// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+// 02110-1301, USA. */
 
 operator NEG (x) = -x;
 
@@ -567,7 +586,7 @@ absorb_miss string function STRING (x, n
 
   v.f = x;
   dst = alloc_string (e, f->w);
-  assert ((formats[f->type].cat & FCAT_STRING) == 0);
+  assert (!fmt_is_string (f->type));
   data_out (dst.string, f, &v);
   return dst;
 }
Index: src/language/expressions/parse.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/parse.c,v
retrieving revision 1.16
diff -u -p -r1.16 parse.c
--- src/language/expressions/parse.c	26 Oct 2006 06:16:36 -0000	1.16
+++ src/language/expressions/parse.c	1 Nov 2006 04:17:26 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -18,26 +18,29 @@
    02110-1301, USA. */
 
 #include <config.h>
+
 #include "private.h"
+
 #include <ctype.h>
 #include <float.h>
 #include <limits.h>
 #include <stdlib.h>
-#include <libpspp/array.h>
-#include <libpspp/alloc.h>
+
+#include "helpers.h"
 #include <data/case.h>
 #include <data/dictionary.h>
-#include <libpspp/message.h>
-#include "helpers.h"
+#include <data/settings.h>
+#include <data/variable.h>
 #include <language/lexer/format-parser.h>
 #include <language/lexer/lexer.h>
 #include <language/lexer/variable-parser.h>
+#include <libpspp/alloc.h>
+#include <libpspp/array.h>
 #include <libpspp/assertion.h>
+#include <libpspp/message.h>
 #include <libpspp/misc.h>
 #include <libpspp/pool.h>
-#include <data/settings.h>
 #include <libpspp/str.h>
-#include <data/variable.h>
 
 /* Declarations. */
 
@@ -351,25 +354,31 @@ type_coercion_core (struct expression *e
       NOT_REACHED ();
 
     case OP_ni_format:
+      msg_disable ();
       if ((*node)->type == OP_format
-          && check_input_specifier (&(*node)->format.f, false)
-          && check_specifier_type (&(*node)->format.f, NUMERIC, false))
+          && fmt_check_input (&(*node)->format.f)
+          && fmt_check_type_compat (&(*node)->format.f, NUMERIC))
         {
+          msg_enable ();
           if (do_coercion)
             (*node)->type = OP_ni_format;
           return true;
         }
+      msg_enable ();
       break;
 
     case OP_no_format:
+      msg_disable ();
       if ((*node)->type == OP_format
-          && check_output_specifier (&(*node)->format.f, false)
-          && check_specifier_type (&(*node)->format.f, NUMERIC, false))
+          && fmt_check_output (&(*node)->format.f)
+          && fmt_check_type_compat (&(*node)->format.f, NUMERIC))
         {
+          msg_enable ();
           if (do_coercion)
             (*node)->type = OP_no_format;
           return true;
         }
+      msg_enable ();
       break;
 
     case OP_num_var:
Index: src/language/lexer/format-parser.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/format-parser.c,v
retrieving revision 1.5
diff -u -p -r1.5 format-parser.c
--- src/language/lexer/format-parser.c	18 Jul 2006 04:57:01 -0000	1.5
+++ src/language/lexer/format-parser.c	1 Nov 2006 04:17:26 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -19,7 +19,7 @@
 
 #include <config.h>
 
-#include <language/lexer/format-parser.h>
+#include "format-parser.h"
 
 #include <ctype.h>
 #include <stdlib.h>
@@ -27,6 +27,7 @@
 #include "lexer.h"
 #include <data/format.h>
 #include <data/variable.h>
+#include <language/lexer/format-parser.h>
 #include <libpspp/message.h>
 #include <libpspp/misc.h>
 #include <libpspp/str.h>
@@ -105,7 +106,7 @@ parse_format_specifier (struct fmt_spec 
   if (!parse_abstract_format_specifier (type, &format->w, &format->d))
     return false;
 
-  if (!fmt_type_from_string (type, &format->type))
+  if (!fmt_from_name (type, &format->type))
     {
       msg (SE, _("Unknown format type \"%s\"."), type);
       return false;
@@ -117,14 +118,14 @@ parse_format_specifier (struct fmt_spec 
 /* Parses a token containing just the name of a format type and
    returns true if successful. */
 bool
-parse_format_specifier_name (int *type) 
+parse_format_specifier_name (enum fmt_type *type) 
 {
   if (token != T_ID) 
     {
       lex_error (_("expecting format type"));
       return false;
     }
-  if (!fmt_type_from_string (ds_cstr (&tokstr), type))
+  if (!fmt_from_name (ds_cstr (&tokstr), type))
     {
       msg (SE, _("Unknown format type \"%s\"."), ds_cstr (&tokstr));
       return false;
Index: src/language/lexer/format-parser.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/format-parser.h,v
retrieving revision 1.1
diff -u -p -r1.1 format-parser.h
--- src/language/lexer/format-parser.h	18 Jul 2006 04:57:01 -0000	1.1
+++ src/language/lexer/format-parser.h	1 Nov 2006 04:17:26 -0000
@@ -29,6 +29,6 @@ struct fmt_spec;
 bool parse_abstract_format_specifier (char type[FMT_TYPE_LEN_MAX + 1],
                                       int *width, int *decimals);
 bool parse_format_specifier (struct fmt_spec *);
-bool parse_format_specifier_name (int *type);
+bool parse_format_specifier_name (enum fmt_type *type);
 
 #endif /* language/lexer/format-parser.h. */
Index: src/language/lexer/range-parser.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/range-parser.c,v
retrieving revision 1.3
diff -u -p -r1.3 range-parser.c
--- src/language/lexer/range-parser.c	1 Nov 2006 02:12:25 -0000	1.3
+++ src/language/lexer/range-parser.c	1 Nov 2006 04:17:26 -0000
@@ -1,3 +1,22 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 2005, 2006 Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
 #include <config.h>
 #include "range-parser.h"
 #include <stdbool.h>
Index: src/language/stats/aggregate.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/aggregate.c,v
retrieving revision 1.17
diff -u -p -r1.17 aggregate.c
--- src/language/stats/aggregate.c	26 Oct 2006 06:16:36 -0000	1.17
+++ src/language/stats/aggregate.c	1 Nov 2006 04:17:27 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -583,21 +583,24 @@ parse_aggregate_functions (const struct 
                     destvar = dict_create_var (agr->dict, dest[i], 0);
                     if (destvar != NULL) 
                       {
+                        struct fmt_spec f;
                         if ((func_index == N || func_index == NMISS)
                             && dict_get_weight (dict) != NULL)
-                          destvar->print = destvar->write = f8_2; 
+                          f = fmt_for_output (FMT_F, 8, 2); 
                         else
-                          destvar->print = destvar->write = function->format;
+                          f = function->format;
+                        destvar->print = destvar->write = f;
                       }
                   }
 	      } else {
+                struct fmt_spec f;
 		v->src = NULL;
 		destvar = dict_create_var (agr->dict, dest[i], 0);
-                if (func_index == N_NO_VARS
-                    && dict_get_weight (dict) != NULL)
-                  destvar->print = destvar->write = f8_2; 
+                if (func_index == N_NO_VARS && dict_get_weight (dict) != NULL)
+                  f = fmt_for_output (FMT_F, 8, 2); 
                 else
-                  destvar->print = destvar->write = function->format;
+                  f = function->format;
+                destvar->print = destvar->write = f;
 	      }
 	  
 	    if (!destvar)
Index: src/language/stats/crosstabs.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/crosstabs.q,v
retrieving revision 1.19
diff -u -p -r1.19 crosstabs.q
--- src/language/stats/crosstabs.q	29 Oct 2006 09:51:36 -0000	1.19
+++ src/language/stats/crosstabs.q	1 Nov 2006 04:17:28 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -3186,7 +3186,7 @@ format_short (char *s, const struct fmt_
   struct fmt_spec fmt_subst;
 
   /* Limit to short string width. */
-  if (formats[fp->type].cat & FCAT_STRING) 
+  if (fmt_is_string (fp->type)) 
     {
       fmt_subst = *fp;
 
Index: src/language/utilities/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/utilities/ChangeLog,v
retrieving revision 1.3
diff -u -p -r1.3 ChangeLog
--- src/language/utilities/ChangeLog	26 Apr 2006 22:06:48 -0000	1.3
+++ src/language/utilities/ChangeLog	1 Nov 2006 04:17:28 -0000
@@ -1,3 +1,13 @@
+Tue Oct 31 20:10:24 2006  Ben Pfaff  <blp@gnu.org>
+
+	* set.q (cmd_set): Drop the `ok' variable, which didn't do
+	anything useful.
+	(extract_cc_token) Adapt to new fmt_number_style.
+	(do_cc) Ditto.
+	(format_cc) Ditto.
+	(show_cc) Change parameter to be an enum fmt_type.  Adjust all
+	callers.
+
 Wed Apr 26 15:06:22 2006  Ben Pfaff  <blp@gnu.org>
 
 	* set.q: Use SN instead of MN for most output from SHOW, because
